All Classes Namespaces Files Functions Variables Typedefs Enumerator Friends Macros Groups
stan::math::vari Class Reference

The variable implementation base class. More...

`#include <vari.hpp>`

Inheritance diagram for stan::math::vari:

## Public Member Functions

| vari (const double x)
| Construct a variable implementation from a value. More...
| vari (const double x, bool stacked)
virtual | ~vari ()
| Throw an illegal argument exception. More...
virtual void | init_dependent ()
| Initialize the adjoint for this (dependent) variable to 1. More...
virtual void | set_zero_adjoint ()
| Set the adjoint value of this variable to 0. More...
Public Member Functions inherited from stan::math::chainable
| chainable ()
| Construct a chainable object. More...
virtual | ~chainable ()
| Chainables are not destructible and should go on the function call stack or be allocated with operator new. More...
virtual void | chain ()
| Apply the chain rule to this variable based on the variables on which it depends. More...

## Public Attributes

const double | val_
| The value of this variable. More...
double | adj_
| The adjoint of this variable, which is the partial derivative of this variable with respect to the root variable. More...

## Friends

class | var
std::ostream & | operator<< (std::ostream &os, const vari *v)
| Insertion operator for vari. More...

## Additional Inherited Members

Static Public Member Functions inherited from stan::math::chainable
static void * | operator new (size_t nbytes)
| Allocate memory from the underlying memory pool. More...
static void | operator delete (void *)
| Delete a pointer from the underlying memory pool. More...

## Detailed Description

The variable implementation base class.

A variable implementation is constructed with a constant value. It also stores the adjoint for storing the partial derivative with respect to the root of the derivative tree.

The chain() method applies the chain rule. Concrete extensions of this class will represent base variables or the result of operations such as addition or subtraction. These extended classes will store operand variables and propagate derivative information via an implementation of chain().

Definition at line 28 of file vari.hpp.

## Constructor & Destructor Documentation

stan::math::vari::vari | ( | const double | x | ) |

inlineexplicit

Construct a variable implementation from a value.

The adjoint is initialized to zero.

All constructed variables are added to the stack. Variables should be constructed before variables on which they depend to insure proper partial derivative propagation. During derivative propagation, the chain() method of each variable will be called in the reverse order of construction.

Parameters

  x | Value of the constructed variable.

Definition at line 56 of file vari.hpp.

stan::math::vari::vari | ( | const double | x,
|  | bool | stacked
| ) |  |

inline

Definition at line 62 of file vari.hpp.

virtual stan::math::vari::~vari | ( |  | ) |

inlinevirtual

Throw an illegal argument exception.

Warning: Destructors should never called for var objects.

Exceptions

  Logic | exception always.

Definition at line 78 of file vari.hpp.

## Member Function Documentation

virtual void stan::math::vari::init_dependent | ( |  | ) |

inlinevirtual

Initialize the adjoint for this (dependent) variable to 1.

This operation is applied to the dependent variable before propagating derivatives.

Reimplemented from stan::math::chainable.

Definition at line 87 of file vari.hpp.

virtual void stan::math::vari::set_zero_adjoint | ( |  | ) |

inlinevirtual

Set the adjoint value of this variable to 0.

Reimplemented from stan::math::chainable.

Definition at line 94 of file vari.hpp.

## Friends And Related Function Documentation

std::ostream& operator<< | ( | std::ostream & | os,
|  | const vari * | v
| ) |  |

friend

Insertion operator for vari.

Prints the current value and the adjoint value.

Parameters

  os | [in, out] ostream to modify
  v | [in] vari object to print.

Returns
  The modified ostream.

Definition at line 107 of file vari.hpp.

friend class var

friend

Definition at line 30 of file vari.hpp.

## Member Data Documentation

double stan::math::vari::adj_

The adjoint of this variable, which is the partial derivative of this variable with respect to the root variable.

Definition at line 42 of file vari.hpp.

const double stan::math::vari::val_

The value of this variable.

Definition at line 36 of file vari.hpp.

The documentation for this class was generated from the following file:

- stan/math/rev/core/vari.hpp

[ Stan Home Page ] © 2011–2015, Stan Development Team.